#include <iostream.h>
#define TRUE 1
#define FALSE 0
#define MaxNodes 5  // .
//   .
typedef struct Zveno *svqz;
typedef struct Zveno
{
  int Element;
  svqz Sled;
};

class Spisok
{
  private:
         int Mas[MaxNodes][MaxNodes];  //  .
         int DD[MaxNodes][MaxNodes];   // .
         int SS[MaxNodes][MaxNodes];   //  .
	 svqz Stack; //   .
         void UDALENIE (svqz *, int *);
         void W_S (svqz *, int);
         void Small_Put (int,int);
  public:
	 Spisok() {Stack = NULL;}
         void Vvod_Ves();
         void Reshenie ();
};

void main()
{
  Spisok A;

  A.Vvod_Ves();
  A.Reshenie();
}

void Spisok::Small_Put (int one, int two)
//  .
{
  svqz St=NULL; //   .
  svqz UkZv;
  int Flag=FALSE; //   .
  int elem1,elem2,k;
  //      .
  W_S (&Stack,two);
  W_S (&Stack,one);
  while (!Flag)
  {
    //   .
    UDALENIE(&Stack,&elem1);
    UDALENIE(&Stack,&elem2);
    if (SS[elem1][elem2]==elem2) //  ...
      if (elem2==two) //   ...
      {
       Flag = TRUE;   //   .
       W_S (&St,elem1);
       W_S (&St,elem2);
      }
      else //    ...
      {
       W_S (&St,elem1); //  .
       W_S (&Stack,elem2); //   .
      }
    else //  .
    {
      W_S (&Stack,elem2); //   .
      k = SS[elem1][elem2];
      W_S (&Stack,k);     //  .
      W_S (&Stack,elem1); //   .
    }
  }
  UkZv = St;
  while ( UkZv != NULL )
  {  cout << (UkZv->Element+1) << " "; 
     UkZv = UkZv->Sled;  }
  cout << endl;
}

void Spisok::W_S (svqz *stk, int Elem)
// Elem   stk.
{
  svqz q=new (Zveno);
  (*q).Element = Elem; 
  (*q).Sled = *stk; *stk = q;
}

void Spisok::UDALENIE (svqz *stk, int *Klad)
//   ,   *stk.
//     -
//   Klad.
{
  svqz q;

  if (*stk==NULL) cout<<"    !\n";
  else
	{ *Klad = (**stk).Element;
	  q = *stk; *stk = (**stk).Sled; delete q; }
}


void Spisok::Vvod_Ves()
//     .
{
  cout << "      :\n";
  for (int i=0;i<MaxNodes;i++)
   for (int j=0;j<MaxNodes;j++)
     {
       cout << " Mas[" << (i+1) << "," << (j+1) << "]: "; 
       cin >> Mas[i][j];
     }
}

void Spisok::Reshenie()
{
  int one,two;
  int i,j;

  //.
  for (i=0;i<MaxNodes;i++)
   for (j=0;j<MaxNodes;j++)
   {
     if (Mas[i][j]>0)  SS[i][j]=j;
     else SS[i][j]=0;
     DD[i][j]=Mas[i][j];
   }
   cout << "\n : ";
   cin >> one; one--;
   cout << " : ";
   cin >> two; two--;

   int ved=0;
   while (ved<MaxNodes)
   {
     for (i=0;i<MaxNodes;i++)
      for (j=0;j<MaxNodes;j++)
        if (i!=j && i!=ved && j!=ved &&
            DD[i][ved]>0 && DD[ved][j]>0) 
          if (DD[i][ved]+DD[ved][j]<DD[i][j] || DD[i][j]==0) 
          {
             DD[i][j]=DD[i][ved]+DD[ved][j];
             SS[i][j]=ved;
          }
          ved++;
   }
   i=one;
   if (SS[i][two]!=two && SS[i][two]!=0) 
     while (SS[i][two]!=two) 
     {
        j=SS[i][two];
        while (SS[i][j]!=j)  j=SS[i][j];
        i=j;
     }
     cout << "\n  (  ): ";
     Small_Put (one, two);
     cout << "     : " << DD[one][two];
}

